/*********************************************************
'*                                                       *
'*             920MHz Radio Sample Codes                 *
'*                                                       *
'* ----------------------------------------------------- *
'*    Module   :   radio.c                               *
'*    Author   :   Li Zheng                              *
'********************************************************/

//샂[h`
#define RF_STANDBY                       0x04

//SX1231WX^AhX
#define REG_DATAMODUL                    0x02
#define REG_BITRATEMSB                   0x03
#define REG_BITRATELSB                   0x04
#define REG_FDEVMSB                      0x05
#define REG_FDEVLSB                      0x06
#define REG_OSC1                         0x0A
#define REG_RXBW                         0x19
#define REG_PREAMBLEMSB                  0x2C
#define REG_PREAMBLELSB                  0x2D
#define REG_SYNCCONFIG                   0x2E
#define REG_SYNCVALUE1                   0x2F
#define REG_SYNCVALUE2                   0x30
#define REG_PACKETCONFIG1                0x37
#define REG_PAYLOADLENGTH                0x38
#define REG_FIFOTHRESH                   0x3C

//SX1231WX^ݒl
#define RF_DATAMODUL_MODULATIONTYPE_FSK	    0x00
#define RF_DATAMODUL_MODULATIONSHAPING_10   0x02
#define RF_BITRATEMSB_50000                 0x02
#define RF_BITRATELSB_50000                 0x80
#define RF_FDEVMSB_25000                    0x01
#define RF_FDEVLSB_25000                    0x9A
#define RF_OSC1_RCCAL_START       	    0x80
#define RF_OSC1_RCCAL_DONE       	    0x40
#define RF_RXBW_DCCFREQ_010                 0x40
#define RF_RXBW_MANT_20                     0x08
#define RF_RXBW_EXP_2                       0x02
#define RF_PREAMBLE_4BYTE                   0x04
#define RF_SYNCSIZE_2BYTE                   0x08
#define RF_SYNC_BYTE1                       0x09
#define RF_SYNC_BYTE2                       0x72             
#define RF_SYNCCONFIG_ON                    0x80     
#define RF_PACKET1_FORMAT_FIXED             0x00
#define RF_PACKET1_CRCAUTOCLEAR_OFF         0x08
#define RF_PACKET1_CRC_OFF                  0x00
#define RF_FIFOTHRESH_TXSTART_FIFONOTEMPTY  0x80
#define RF_PAYLOADLENGTH                    11 

void spiInit(void);
void radioMode(char mode);
char spiReadReg(char addr);
void spiWriteReg(char addr, char val);

void radioChannel(char chan);
void radioPower(char power);

//RF IC`bv  
void radioInit(char chan, char power)
{    
  //SPI
  spiInit();    
 
  //ҋ@[hɐݒ
  radioMode(RF_STANDBY); 
  
  // RCUHZ(dĂ1̂) //
  spiWriteReg(0x57,0x80); 
  spiWriteReg(REG_OSC1,spiReadReg(REG_OSC1) | RF_OSC1_RCCAL_START); 
  while ((spiReadReg(REG_OSC1) & RF_OSC1_RCCAL_DONE) == 0x00); 
  spiWriteReg(REG_OSC1, spiReadReg(REG_OSC1) | RF_OSC1_RCCAL_START); 
  while ((spiReadReg(REG_OSC1) & RF_OSC1_RCCAL_DONE) == 0x00);
  spiWriteReg(0x57,0x00); 
      
  //`lSgݒ
  radioChannel(chan);
  
  //Md͐ݒ 
  radioPower(power);
  
  //pPbgʐM, FSKϒ, KEXtB^BT=0.5
  spiWriteReg(REG_DATAMODUL,RF_DATAMODUL_MODULATIONTYPE_FSK | 
              RF_DATAMODUL_MODULATIONSHAPING_10); 
  
  //ϒwM=1, gΈFdev=25kHz
  spiWriteReg(REG_FDEVMSB,RF_FDEVMSB_25000); 
  spiWriteReg(REG_FDEVLSB,RF_FDEVLSB_25000);
  
  //f[^[g=50kbps
  spiWriteReg(REG_BITRATEMSB,RF_BITRATEMSB_50000); 
  spiWriteReg(REG_BITRATELSB,RF_BITRATELSB_50000); 
  //Mѕݒ RxBW=100KHz FreqDCC = 4%*RXBW = 995kHz
  spiWriteReg(REG_RXBW,RF_RXBW_DCCFREQ_010 | RF_RXBW_MANT_20 | RF_RXBW_EXP_2); 

  //v~A=4oCg
  spiWriteReg(REG_PREAMBLELSB,RF_PREAMBLE_4BYTE);  
  //[h=2oCg 
  spiWriteReg(REG_SYNCCONFIG,RF_SYNCSIZE_2BYTE | RF_SYNCCONFIG_ON); 
  //[h=0x09,0x72
  spiWriteReg(REG_SYNCVALUE1,RF_SYNC_BYTE1);   
  spiWriteReg(REG_SYNCVALUE2,RF_SYNC_BYTE2);   
  
  //Œ蒷pPbg,CRC`FbN, AhXtB^
  spiWriteReg(REG_PACKETCONFIG1,RF_PACKET1_FORMAT_FIXED | 
    RF_PACKET1_CRCAUTOCLEAR_OFF | RF_PACKET1_CRC_OFF);
  //MyC[hݒ
  spiWriteReg(REG_PAYLOADLENGTH,RF_PAYLOADLENGTH);  
  //TXMݒ  
  spiWriteReg(REG_FIFOTHRESH, RF_FIFOTHRESH_TXSTART_FIFONOTEMPTY);
}  






 



