/*********************************************************
'*                                                       *
'*             920MHz Radio Sample Codes                 *
'*                                                       *
'* ----------------------------------------------------- *
'*    Module   :   radioRecv.c                           *
'*    Author   :   Li Zheng                              *
'********************************************************/
#include <in430.h>
#include <msp430x44x.h>

//`l0(920.6MHz)ƑMd13dBm
#define MY_CHANNEL                       0
#define MY_TXPOWER                       13 
#define RF_PAYLOADLENGTH                 11  

//샂[h`              
#define RF_RECEIVER                      0x10

//SX1231WX^AhX
#define REG_FIFO                         0x00 		
#define REG_DIOMAPPING1	                 0x25

//SX1231WX^ݒl
#define RF_DIOMAPPING_RX                 0x40

char spiReadReg(char addr);
void spiWriteReg(char addr, char val);

void radioInit(char chan, char power);
void radioMode(char mode);

unsigned short calcCRC16(char *data, char len);

//MvO
void radioRecv( void )
{      
  //LED|[g
  P1DIR |= BIT0;    
  //RF IC`bv  
  radioInit(MY_CHANNEL, MY_TXPOWER);
        
  //ML->H 荞ݔ
  P1IES &= ~BIT7;
  //M荞݃tbONA  
  P1IFG &= ~BIT7;
  //M荞ݗL
  P1IE |= BIT7;
  //M[hɐ؂ւ  
  radioMode(RF_RECEIVER);
  //RFo̓sPayloadReadyMɐݒ
  spiWriteReg(REG_DIOMAPPING1,RF_DIOMAPPING_RX);   
  
  //荞ݗL
  __enable_interrupt();
  //x~[hɓ
  __low_power_mode_4();
}

//MݏvO
#pragma vector = PORT1_VECTOR
__interrupt void rx_interrupt(void)
{   
  char rxFrame[RF_PAYLOADLENGTH];

  //M荞݃tbONA
  P1IFG &= ~BIT7;  
  
  //Mt[ǂݎ
  for(char i=0; i<RF_PAYLOADLENGTH; i++){
    rxFrame[i] = spiReadReg(REG_FIFO);
  }

  //CRCŌ`FbN, sȎMt[̂Ă
  if (calcCRC16(rxFrame, RF_PAYLOADLENGTH))
    return;
  
  //LED_    
  P1OUT ^= BIT0;  
  //Mt[
  //......
  return;
}
